/*
 *	visite du complexe inconnu / 2 mai 2023
 */

#version 3.7;

global_settings {
		ambient_light rgb <0.05, 0.05, 0.05>
		assumed_gamma 1.0
		max_trace_level 5
		}

/* system includes */
#include  "colors.inc"
#include  "textures.inc"
#include  "stones.inc"
#include  "metals.inc"
#include  "woods.inc"
#include  "glass.inc"

/*** my includes ***/

#include  "values.inc"

#declare NormClock = clock/2000;		// XXX XXX XXX XXX XXX XXX

#include  "reperes.inc"
#include  "vaisselle.inc"
#include  "meubles.inc"
#include  "lumieres.inc"
#include  "supports.inc"			// new Thu 22 Dec 2022
#include  "cubes.inc"				// added Sun 08 Jan 2023

#include  "elements.inc"
#include  "bidules.inc"
#include  "decorations.inc"
#include  "grostrucs.inc"
#include  "rotonde.inc"
#include  "chateau.inc"
#include  "annexe.inc"
#include  "univers.inc"
#include  "jardin.inc"
#include  "steles.inc"
#include  "monster.inc"
#include  "machine.inc"

/*    ------------------------------------------------------    */
/* *		assemblage final			        */

#declare ShowWall = 1;
#include  "batiment.inc"
#include "assemblage.inc"

object { Assemblage_Final }

/*    ------------------------------------------------------    */

#debug concat("\n\tPOV clock  = ", str(clock,     0, 5), "\n")
#debug concat("\n\tNormClock  = ", str(NormClock, 0, 5), "\n")

#local AngleCam   = 60;
#local ShowRepere = 0;

#macro Trigger( N )
   N * (2000 / 11)
#end

#if (clock < Trigger(1))			//-----------------
  #debug  "\t--- default scene\n"
  #local   CamX = -2.2 + (5.7*NormClock);
  #local   CamY = 2.99 + (4.567*NormClock);
  #local   CamZ = Sz_Z - (18+17*NormClock);
  #local   LatX = 11.50 + 28*NormClock;
  #local   LatY = 2.65;
  #local   LatZ = Sz_Z * 1.33333;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(2))			//-----------------
  #debug  "\t--- jardin\n"
  #local   CamX = Sz_X + 16.00;
  #local   CamY = 22.30 + 4.00*Cos_010(NormClock);
  #local   CamZ = 36;
  #local   LatX = Sz_X - 16 + 131*NormClock;
  #local   LatY = 2;
  #local   LatZ = -6;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(3))			//-----------------
  #debug "\t--- anneau et chaise\n"
  #local   CamX = Sz_X - (1.8+NormClock);
  #local   CamY = 1.20 - NormClock;
  #local   CamZ = - (14.20 + (NormClock*17.5));
  #local   LatX = 15.67;
  #local   LatY = 1.80;
  #local   LatZ =  -(Sz_Z*0.54);
  #local   AngleCam = 88;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(4))			//-------------------
  #debug  "\t--- annexe\n"
  #local   CamX = - (Sz_X + 5);
  #local   CamY = 0.33 + NormClock;
  #local   CamZ = NormClock;
  #local   LatX = - (Sz_X + 17);
  #local   LatY = 5.155;
  #local   LatZ = 15 * cos(NormClock*14.00);
  #local   ShowRepere = 1;
  #local   AngleCam = 140 - (80*NormClock);

#elseif (clock < Trigger(5))			//------------------------
  #debug "\t--- cinema rotonde\n"
  #local   CamX = (19*NormClock) - (Sz_X*0.30);
  #local   CamY = 1.10 + NormClock;
  #local   CamZ = - (Sz_Z * 0.52);
  #local   LatX = -7.85 + (9*NormClock);
  #local   LatY = 2.90;
  #local   LatZ = - (Sz_Z+5);
  #local   AngleCam = 71;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(6))			//------------------------
  #debug  "\t--- truc dans un coin\n"
  #local   CamX = - (Sz_X - 5 - (9.99 * NormClock));
  #local   CamY = 2.84 + (2.45*NormClock);
  #local   CamZ = - (Sz_Z - 9 - (4.80 * NormClock));
  #local   LatX = - (Sz_X - 1.8);
  #local   LatY = 1.23;
  #local   LatZ = - (Sz_Z - 1.8);
  #local   AngleCam = 39;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(7))			//---------------------------
  #debug   "\t*** vue d'en haut ***\n"
  #local   CamX = 0;
  #local   CamY = -5.51 + (NormClock*333.333);
  #local   CamZ = -33.333;
  #local   LatX = -8 + (8*NormClock);
  #local   LatY = 2.50 - (NormClock*10);
  #local   LatZ = 0;
  #local   AngleCam = 38;
  #local   ShowRepere = 0;
  #local   AngleCam = 35;

#elseif (clock < Trigger(8))			//---------------------------
  #debug   "=== Julia ==="
  #local   CamX = NormClock*4;
  #local   CamY = 1.05 + (NormClock*3);
  #local   CamZ = Sz_Z - 11.25*NormClock;
  #local   LatX = -4.75;
  #local   LatY = 1.95;
  #local   LatZ = Sz_Z - 6.25;
  #local   AngleCam = 42;
  #local   ShowRepere = 0;

/* mettre ici vision d'un des cubes */
#elseif (clock < Trigger(9))			//---------------------------
  #debug   "=== Les Cubes ==="
  #local   CamX = 3.20 + (16*NormClock);
  #local   CamY = 3.0000;
  #local   CamZ = -24.444;
  #local   LatX = -2.60;
  #local   LatY = Sz_Y - 2.05;
  #local   LatZ = -18.40;
  #local   AngleCam = 49;
  #local   ShowRepere = 0;

#elseif (clock < Trigger(10))			//---------------------------
  #debug   "=== Horloge vue du jardin ==="
  #local   CamX = X_jardin+28;
  #local   CamY = 1.20 + (14 * NormClock);
  #local   CamZ = Z_jardin;
  #local   LatX = Sz_X;
  #local   LatY = Sz_Y + 4.01 - NormClock;
  #local   LatZ = 0.25;
  #local   AngleCam = 13;
  #local   ShowRepere = 0;

#else						//---------------------------
  //--- un autre truc
  #local   CamX = 13 + (4*NormClock);
  #local   CamY = 7;
  #local   CamZ = -12 + NormClock;
  #local   LatX = 12.20;
  #local   LatY = 1.00;
  #local   LatZ = -(Sz_Z-5.80);
  #local   AngleCam = 36 - (20*NormClock);
  #local   ShowRepere = 0;

#end						//-----------------


#debug concat("\n\tShowRepere  = ", str(ShowRepere, 0, 1), "\n\n")
#local PosRep = Interpolate(<CamX, CamY, CamZ>, <LatX, LatY, LatZ>, 0.50000);

#if (ShowRepere)
  object { Repere  translate PosRep }
#end

camera	{
	location	<CamX, CamY, CamZ>
	look_at		<LatX, LatY, LatZ>
	right		x*image_width/image_height
	angle 		AngleCam
	}

/*    ------------------------------------------------------    */
